Name:          go
Version:       1.19.4
Release:       1mamba
Summary:       The Go programming language
Group:         Applications/Development
Vendor:        openmamba
Distribution:  openmamba
Packager:      Silvan Calarco <silvan.calarco@mambasoft.it>
URL:           https://go.dev/
Source:        https://github.com/golang/go.git/go%{version}/go-%{version}.tar.bz2
Patch0:        go-1.10.1-default-buildmode-pie.patch
License:       BSD
## AUTOBUILDREQ-BEGIN
BuildRequires: glibc-devel
## AUTOBUILDREQ-END
BuildRequires: go
#BuildRequires: gcc-go >= 8.1.0
Provides:      go-pie
Obsoletes:     go-pie < 1.16.3

%description
The Go programming language.

# Fedora: 
# Don't alter timestamps of especially the .a files (or else go will rebuild later)
# Actually, don't strip at all since we are not even building debug packages and this corrupts the dwarf testdata
#% debug_package
%global __strip /bin/true

%prep
%setup -q
#-D -T
#:<< _EOF

%define _use_internal_dependency_generator 0

%define __find_provides %{_builddir}/go-%{version}/find_provides.sh
cat > %{_builddir}/go-%{version}/find_provides.sh <<_EOF
#! /bin/sh
%{_prefix}/lib/rpm/find-provides %{buildroot} %{_target_cpu}
_EOF
chmod +x %{_builddir}/go-%{version}/find_provides.sh

%define __find_requires %{_builddir}/go-%{version}/find_requires.sh
cat > %{_builddir}/go-%{version}/find_requires.sh <<_EOF
#! /bin/sh
grep -v %{buildroot}%{_libdir}/go/src/ | \
%{_prefix}/lib/rpm/find-requires %{buildroot} %{_target_cpu} 2>/dev/null
_EOF
chmod +x %{_builddir}/go-%{version}/find_requires.sh

%build
#:<< _EOF
export GOPATH="%{_builddir}/"
export GOROOT="$PWD"
export GOROOT_FINAL=%{_libdir}/go
export GO_LDFLAGS="-linkmode internal"
export CGO_ENABLED=1

## Use gcc-go as bootstrap compiler
#export GOROOT_BOOTSTRAP=/
#sed -i "s|\$GOROOT_BOOTSTRAP/bin/go|/usr/bin/gcc-go|" src/make.bash src/make.rc
#sed -i "s|/bin/go|/usr/bin/go|" src/cmd/dist/buildtool.go

# golang
export GOROOT_BOOTSTRAP=%{_libdir}/go

cd src
./make.bash --no-clean -v
cd ..

PATH="$PWD/bin:$PATH" go install -v -buildmode=shared std

%ifarch x86_64
PATH="$PWD/bin:$PATH" go install -v -race std
%endif

%install
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"
export GOPATH="`pwd`/"
options=(!strip staticlibs)

install -d %{buildroot}{%{_bindir},%{_libdir}/go,%{_docdir}/go}
  
cp -a bin pkg src lib misc %{buildroot}%{_libdir}/go
cp -r doc/* %{buildroot}%{_docdir}/go

ln -sf %{_docdir}/go %{buildroot}%{_libdir}/go/doc

install -Dm644 LICENSE %{buildroot}%{_datadir}/licenses/go/LICENSE
install -Dm644 VERSION %{buildroot}%{_libdir}/go/VERSION

rm -rf %{buildroot}%{_libdir}/go/pkg/bootstrap
rm -rf %{buildroot}%{_libdir}/go/pkg/tool/*/api
rm -rf %{buildroot}%{_libdir}/go/src/*.rc

%clean
[ "%{buildroot}" != / ] && rm -rf "%{buildroot}"

%post
/usr/sbin/alternatives --install \
   %{_bindir}/go go %{_libdir}/go/bin/go 50
/usr/sbin/alternatives --install \
   %{_bindir}/gofmt gofmt %{_libdir}/go/bin/gofmt 50
:

%preun
# erase
if [ $1 -eq 0 ]; then
   /usr/sbin/update-alternatives --remove go %{_libdir}/go/bin/go
   /usr/sbin/update-alternatives --remove gofmt %{_libdir}/go/bin/gofmt
fi
:

%files
%defattr(-,root,root)
%dir %{_libdir}/go
%{_libdir}/go/*
%dir %{_datadir}/doc/go
%{_datadir}/doc/go/*
%{_datadir}/licenses/go/LICENSE
#%doc README.md

%changelog
* Wed Dec 07 2022 Automatic Build System <autodist@mambasoft.it> 1.19.4-1mamba
- automatic version update by autodist

* Wed Nov 02 2022 Automatic Build System <autodist@mambasoft.it> 1.19.3-1mamba
- automatic version update by autodist

* Wed Oct 05 2022 Automatic Build System <autodist@mambasoft.it> 1.19.2-1mamba
- automatic version update by autodist

* Wed Sep 07 2022 Automatic Build System <autodist@mambasoft.it> 1.19.1-1mamba
- automatic version update by autodist

* Wed Aug 03 2022 Automatic Build System <autodist@mambasoft.it> 1.19-1mamba
- automatic version update by autodist

* Tue Aug 02 2022 Automatic Build System <autodist@mambasoft.it> 1.18.5-1mamba
- automatic version update by autodist

* Wed Jul 13 2022 Automatic Build System <autodist@mambasoft.it> 1.18.4-1mamba
- automatic version update by autodist

* Thu Jun 02 2022 Automatic Build System <autodist@mambasoft.it> 1.18.3-1mamba
- automatic version update by autodist

* Wed May 11 2022 Automatic Build System <autodist@mambasoft.it> 1.18.2-1mamba
- automatic version update by autodist

* Wed Apr 13 2022 Automatic Build System <autodist@mambasoft.it> 1.18.1-1mamba
- automatic version update by autodist

* Wed Mar 16 2022 Automatic Build System <autodist@mambasoft.it> 1.18-1mamba
- automatic version update by autodist

* Fri Mar 04 2022 Automatic Build System <autodist@mambasoft.it> 1.17.8-1mamba
- automatic version update by autodist

* Fri Feb 11 2022 Automatic Build System <autodist@mambasoft.it> 1.17.7-1mamba
- automatic version update by autodist

* Fri Jan 07 2022 Automatic Build System <autodist@mambasoft.it> 1.17.6-1mamba
- automatic version update by autodist

* Thu Dec 09 2021 Automatic Build System <autodist@mambasoft.it> 1.17.5-1mamba
- automatic version update by autodist

* Fri Dec 03 2021 Automatic Build System <autodist@mambasoft.it> 1.17.4-1mamba
- automatic version update by autodist

* Thu Nov 04 2021 Automatic Build System <autodist@mambasoft.it> 1.17.3-1mamba
- automatic version update by autodist

* Fri Oct 08 2021 Automatic Build System <autodist@mambasoft.it> 1.17.2-1mamba
- automatic version update by autodist

* Fri Sep 10 2021 Automatic Build System <autodist@mambasoft.it> 1.17.1-1mamba
- automatic version update by autodist

* Tue Aug 17 2021 Automatic Build System <autodist@mambasoft.it> 1.17-1mamba
- automatic version update by autodist

* Fri Aug 06 2021 Automatic Build System <autodist@mambasoft.it> 1.16.7-1mamba
- automatic version update by autodist

* Tue Jul 13 2021 Automatic Build System <autodist@mambasoft.it> 1.16.6-1mamba
- automatic version update by autodist

* Fri Jun 04 2021 Automatic Build System <autodist@mambasoft.it> 1.16.5-1mamba
- automatic version update by autodist

* Fri May 07 2021 Automatic Build System <autodist@mambasoft.it> 1.16.4-1mamba
- automatic version update by autodist

* Thu May 06 2021 Automatic Build System <autodist@mambasoft.it> 1.16.3-1mamba
- automatic version update by autodist

* Sun Aug 16 2020 Silvan Calarco <silvan.calarco@mambasoft.it> 1.14.7-2mamba
- install alternatives for go and gofmt binaries

* Fri Aug 07 2020 Automatic Build System <autodist@mambasoft.it> 1.14.7-1mamba
- automatic version update by autodist

* Tue Jul 21 2020 Automatic Build System <autodist@mambasoft.it> 1.14.6-1mamba
- automatic version update by autodist

* Wed Jul 15 2020 Automatic Build System <autodist@mambasoft.it> 1.14.5-1mamba
- automatic version update by autodist

* Wed Jun 03 2020 Automatic Build System <autodist@mambasoft.it> 1.14.4-1mamba
- automatic version update by autodist

* Tue May 19 2020 Automatic Build System <autodist@mambasoft.it> 1.14.3-1mamba
- automatic version update by autodist

* Fri Apr 10 2020 Automatic Build System <autodist@mambasoft.it> 1.14.2-1mamba
- automatic version update by autodist

* Thu Dec 26 2019 Automatic Build System <autodist@mambasoft.it> 1.13.5-1mamba
- automatic version update by autodist

* Sat Nov 02 2019 Automatic Build System <autodist@mambasoft.it> 1.13.4-1mamba
- automatic version update by autodist

* Sun Oct 20 2019 Automatic Build System <autodist@mambasoft.it> 1.13.3-1mamba
- automatic version update by autodist

* Thu Oct 03 2019 Automatic Build System <autodist@mambasoft.it> 1.13.1-1mamba
- automatic version update by autodist

* Wed Sep 11 2019 Automatic Build System <autodist@mambasoft.it> 1.13-1mamba
- automatic version update by autodist

* Mon Jan 28 2019 Automatic Build System <autodist@mambasoft.it> 1.11.5-1mamba
- automatic version update by autodist

* Sat Dec 22 2018 Automatic Build System <autodist@mambasoft.it> 1.11.4-1mamba
- automatic version update by autodist

* Fri Dec 14 2018 Automatic Build System <autodist@mambasoft.it> 1.11.3-1mamba
- automatic version update by autodist

* Mon Nov 05 2018 Automatic Build System <autodist@mambasoft.it> 1.11.2-1mamba
- automatic version update by autodist

* Sat Oct 06 2018 Automatic Build System <autodist@mambasoft.it> 1.11.1-1mamba
- automatic version update by autodist

* Mon Sep 10 2018 Silvan Calarco <silvan.calarco@mambasoft.it> 1.11-2mamba
- rename go and go-fmt to [-pie] for cohexistence woth gcc-go

* Tue Sep 04 2018 Automatic Build System <autodist@mambasoft.it> 1.11-1mamba
- automatic version update by autodist

* Sun Jun 24 2018 Silvan Calarco <silvan.calarco@mambasoft.it> 1.10.3-2mamba
- rebuilt with libgo 8.1.0

* Fri Jun 08 2018 Automatic Build System <autodist@mambasoft.it> 1.10.3-1mamba
- automatic version update by autodist

* Wed May 02 2018 Automatic Build System <autodist@mambasoft.it> 1.10.2-1mamba
- automatic version update by autodist

* Tue Apr 24 2018 Silvan Calarco <silvan.calarco@mambasoft.it> 1.10.1-2mamba
- remove testdata binaries for other architectures

* Thu Apr 19 2018 Silvan Calarco <silvan.calarco@mambasoft.it> 1.10.1-1mamba
- package created using the webbuild interface
